<?php
if (!defined('ABSPATH')) {
    exit();
}
// ###################### Add Pages Admin ######################
function register_coyote_np_posts_submenu_page() {
	add_menu_page('Prev and Next', 'Prev and Next', 'manage_options', 'coyote-next-prev-posts','coyote_np_posts_geral', plugin_dir_url(__FILE__).'images/icon.png');   
}

add_action('admin_menu', 'register_coyote_np_posts_submenu_page');


// ###################### Function to load the styles ######################
function coyote_np_posts_styles() {
	if ( isset($_GET['page']) ) {		
		
		if ($_GET['page'] === 'coyote-next-prev-posts') {
			wp_register_style('coyote_np_posts_styles', plugin_dir_url(__FILE__) . 'admin/css/style.css', false, false);        

			wp_enqueue_style('coyote_np_posts_styles');
			wp_enqueue_style('thickbox');
			wp_enqueue_style('wp-color-picker');
		   
		} 
	}	
}

add_action('admin_enqueue_scripts', 'coyote_np_posts_styles');

// ###################### Function to load the scripts jquery ######################
function coyote_np_posts_scripts() {
	if ( isset($_GET['page']) ) {		
		
		if ($_GET['page'] === 'coyote-next-prev-posts') {
			
			wp_register_script('coyote_np_posts-script', plugin_dir_url(__FILE__) . 'admin/js/custom.js', false, false, true);       

			wp_enqueue_script('jquery');
			wp_enqueue_script('jquery-ui-core');
			wp_enqueue_script('jquery-ui-tabs');			
			wp_enqueue_script('wp-color-picker');
			wp_enqueue_script('jquery-ui-sortable');
			wp_enqueue_script('coyote_np_posts-script');
		   
		} 
	}    
}

add_action('admin_enqueue_scripts', 'coyote_np_posts_scripts');

// ###################### Function to activate translation ######################
function coyote_np_posts_textdomain() {
    load_plugin_textdomain(COYOTE_NP_POSTS_TEXT_DOMAIN, FALSE, basename(dirname(__FILE__)) . '/languages/');
}

add_action('plugins_loaded', 'coyote_np_posts_textdomain');

// ###################### Register settings ######################
function coyote_np_posts_codes() {
    register_setting('coyote_np_posts_options', 'coyote_np_posts_options_item');
}

add_action('admin_init', 'coyote_np_posts_codes');


// #################### Insert Arrows ######################
function cvf_convert_object_to_array($data) {

    if (is_object($data)) {
        $data = get_object_vars($data);
    }

    if (is_array($data)) {
        return array_map(__FUNCTION__, $data);
    }
    else {
        return $data;
    }
}
function coyote_np_get_adjacent_post($post_id , $post_type ) {    
	global $wpdb;    
    $this_post = get_post($post_id);
    $in_same_cat = false;
    $excluded_categories = '';
    $previous = false;
    $next_post = get_adjacent_post($in_same_cat,$excluded_categories,$previous);
	$next_post = cvf_convert_object_to_array($next_post);
    $prev_post= get_previous_post();
	$prev_post= cvf_convert_object_to_array($prev_post);
    
	
	$ids_groups = array();
	if($prev_post){ $ids_groups [0] = $prev_post['ID']; }
	if($next_post){ $ids_groups [1]= $next_post['ID']; }			
	
    return $ids_groups;
}
function coyote_np_posts_arrows() { 
	global $post; 
	global $wpdb;
	$current_id = get_the_ID();
	$current_type = get_post_type($current_id);	
	$post_types = get_option('coyote_np_post_type');
	
	// check metabox
	$key_control = get_post_meta( $current_id, 'meta_coyote_np_posts_control', true );	
	
	
	// Appearance
	$icons_color = get_option('coy_icons_color');
	if(empty($icons_color )){
		$icons_color  = 'white';
	}	
	
	$icon_arrow  = '30';
		
	if(empty($post_types)){
		$post_types = array('');
	}
	$shadow = get_option('coy_content_shadow');
		
	if ( ! empty( $key_control ) && ( $key_control === 'custom' ) ) { ?>
					
				<?php
				$custom_prev = get_post_meta( get_the_ID(), 'meta_coyote_np_posts_id_prev', true );	
				$custom_text_prev = get_post_meta( get_the_ID(), 'meta_coyote_np_posts_id_prev_custom_text', true );	
				$custom_next = get_post_meta( get_the_ID(), 'meta_coyote_np_posts_id_next', true );
				$custom_text_next = get_post_meta( get_the_ID(), 'meta_coyote_np_posts_id_next_custom_text', true );
				?>
				
					<?php if($custom_prev) : ?>
					<div class="coyote-np-nav-prev">
					<div class="np-prev">
						<span class="arrow-icon">
						<img src="<?php echo plugin_dir_url(__FILE__).'images/icons/'.$icon_arrow.coyote_np_posts_icons_front($icons_color).'.png'; ?>" width="32" height="32" class="arrow-icon-image invert-icon">
						</span>
						
						<?php $url = get_permalink($custom_prev); ?>
						<?php $prev_post_id = url_to_postid( $url ); ?>
							<div class="np-content <?php echo $shadow; ?>">
								<div class="np-thumb-div">
										<a href="<?php echo get_permalink($custom_prev)?>">
								<?php if ( has_post_thumbnail($prev_post_id) ) { ?>
								<?php echo get_the_post_thumbnail( $prev_post_id, 'thumbnail', array( 'class' => 'np-thumb' ) ); ?>
								<?php }	else {
											echo '<img src="' . plugin_dir_url(__FILE__).'images/default.png" class="np-thumb" />';
										}
										?>
										</a>
								</div>
								<div class="np-thumb-text">
								<h3><a href="<?php echo get_permalink($custom_prev)?>"><?php echo substr(get_the_title($custom_prev), 0, get_option('coy_title_number')) ?></a></h3>
								<p><?php echo $custom_text_prev; ?></p>
								
							</div>								
							</div>
					</div>
					</div>
				<?php endif; ?>
				<?php if($custom_next) : ?>
				<div class="coyote-np-nav-next">
					<div class="np-next">						
						<span class="arrow-icon">
						<img src="<?php echo plugin_dir_url(__FILE__).'images/icons/'.$icon_arrow.coyote_np_posts_icons_front($icons_color).'.png'; ?>" width="32" height="32" class="arrow-icon-image">
						</span>
						
						<?php $url = get_permalink($custom_next); ?>
						<?php $next_post_id = url_to_postid( $url ); ?>
							<div class="np-content <?php echo $shadow; ?>">
								<div class="np-thumb-div">
									<a href="<?php echo get_permalink($custom_next)?>">
								<?php if ( has_post_thumbnail($next_post_id) ) { ?>
								<?php echo get_the_post_thumbnail( $next_post_id, 'thumbnail', array( 'class' => 'np-thumb' ) ); ?>
								<?php }	else {
											echo '<img src="' . plugin_dir_url(__FILE__).'images/default.png" class="np-thumb" />';
										}
										?>
										</a>
								</div>
								<div class="np-thumb-text">
								<h3><a href="<?php echo get_permalink($custom_next)?>"><?php echo substr(get_the_title($custom_next), 0, get_option('coy_title_number')); ?></a></h3>
								<p><?php echo $custom_text_next; ?></p>
								
							</div>								
							</div>
					</div>
				</div>		
				<?php endif; ?>
	
	
	
	<?php } else { ?>
			<?php 
						
			$ids = coyote_np_get_adjacent_post($current_id , $current_type );
			
			if (array_key_exists("0", $ids)) {
				$prev = $ids[0]; 
			} else { $prev = ''; }
			if (array_key_exists("1", $ids)) {
				$next = $ids[1];
			} else { $next = ''; }
				 
			?>				
			<?php if($prev) : ?>
					<div class="coyote-np-nav-prev">
					<div class="np-prev">						
						<span class="arrow-icon">
							<img src="<?php echo plugin_dir_url(__FILE__).'images/icons/'.$icon_arrow.coyote_np_posts_icons_front($icons_color).'.png'; ?>" width="32" height="32" class="arrow-icon-image invert-icon">
						</span>		
							<div class="np-content <?php echo $shadow; ?>">
								<div class="np-thumb-div">
										<a href="<?php echo get_permalink($prev)?>">
								<?php if ( has_post_thumbnail($prev) ) { ?>
								<?php echo get_the_post_thumbnail( $prev, 'thumbnail', array( 'class' => 'np-thumb' ) ); ?>
								<?php }	else {
											echo '<img src="' . plugin_dir_url(__FILE__).'images/default.png" class="np-thumb" />';
										}
										?>
										</a>
								</div>
								<div class="np-thumb-text"><h3><a href="<?php echo get_permalink($prev)?>"><?php echo substr(get_the_title($prev), 0, get_option('coy_title_number')); ?><?php //echo get_the_title($prev); ?></a></h3>
								<?php if( $current_type === 'product'){ ?>
											<p class="np-price-product"><?php global  $woocommerce; $prev_product = wc_get_product( $prev );   echo get_woocommerce_currency_symbol().''.$prev_product->get_price(); ?></p>
											<p>
											<?php $prev_categories = get_the_category( $prev );
											if(!empty($prev_categories)) { echo( $prev_categories[0]->cat_product_name ); }
											
											$terms = get_the_terms( $prev, 'product_cat' );
											$i =0;								
												foreach ($terms as $term) {
													$i++;										
													$cat_name[$i] = $term->name;
													break;
												}
											echo implode(', ', $cat_name);	
											?>	
											</p>										
								<?php } else { ?>
											<p>
											<?php $prev_categories = get_the_category( $prev );
											if(!empty($prev_categories)) { echo( $prev_categories[0]->cat_name ); } ?>
											</p>
								<?php } ?>	
							</div>								
							</div>
					</div>
					</div>
				<?php endif; ?>
				<?php if($next) : ?>
				<div class="coyote-np-nav-next">
					<div class="np-next">						
						<span class="arrow-icon"><img src="<?php echo plugin_dir_url(__FILE__).'images/icons/'.$icon_arrow.coyote_np_posts_icons_front($icons_color).'.png'; ?>" width="32" height="32" class="arrow-icon-image">
						</span>		
							<div class="np-content <?php echo $shadow; ?>">
								<div class="np-thumb-div">
									<a href="<?php echo get_permalink($next)?>">
								<?php if ( has_post_thumbnail($next) ) { ?>
								<?php echo get_the_post_thumbnail( $next, 'thumbnail', array( 'class' => 'np-thumb' ) ); ?>
								<?php }	else {
											echo '<img src="' . plugin_dir_url(__FILE__).'images/default.png" class="np-thumb" />';
										}
										?>
										</a>
								</div>
								<div class="np-thumb-text"><h3><a href="<?php echo get_permalink($next)?>"><?php echo substr(get_the_title($next), 0, get_option('coy_title_number')); ?><?php //echo get_the_title($next); ?></a></h3>
								<?php if( $current_type === 'product'){ ?>
											<p class="np-price-product"><?php global  $woocommerce; $next_product = wc_get_product( $next );   echo get_woocommerce_currency_symbol().''.$next_product->get_price(); ?></p>
											<p>
											<?php $next_categories = get_the_category( $next );
											if(!empty($next_categories)) { echo( $next_categories[0]->cat_product_name ); }
											
											$terms = get_the_terms( $next, 'product_cat' );
											$i =0;								
												foreach ($terms as $term) {
													$i++;										
													$cat_name[$i] = $term->name;
													break;
												}
											echo implode(', ', $cat_name);	
											?>	
											</p>										
								<?php } else { ?>
											<p>
											<?php $next_categories = get_the_category( $next );
											if(!empty($next_categories)) { echo( $next_categories[0]->cat_name ); } ?>
											</p>
								<?php } ?>	
							</div>								
							</div>
					</div>
				</div>		
				<?php endif; ?>
			
		<?php } 

} 

function coyote_np_register_plugin_styles() {
	// Register Styles
    wp_register_style('coyote_np_style', plugin_dir_url(__FILE__) . 'frontend/css/coyote-np-style.css', false, false);
    
    wp_enqueue_style('coyote_np_style');	
}
add_action( 'wp_enqueue_scripts', 'coyote_np_register_plugin_styles' );


// Register Inline Styles
function coyote_np_styles_inline() {
	// Variables
	
	// Titles
    $title_color = get_option('coy_title_color');
	$title_color_hover = get_option('coy_title_color_hover');
	$title_font_default = get_option('coy_font_default');
    $font_weight = get_option('coy_font_weight');
	$standard_family = get_option('coy_standard_family');	
	
	
	// Subtitles
	$subtitle_color = get_option('coy_subtitle_color');
	$subtitle_font_default = get_option('coy_subtitle_font_default');
    $subfont_standard_family = get_option('coy_subtitle_standard_family');
	
	// Appearance
	$content_background = get_option('coy_content_background');
    $content_arrow = get_option('coy_content_arrow');

    // Font for title
    if ($title_font_default == 'inherit') {
        $title_font_family = 'inherit';
    } elseif ($title_font_default == 'standart') {
        $title_font_family = $standard_family;
    } else {
        $title_font_family = 'inherit';
    }

    // Font for Subtitle
    if ($subtitle_font_default == 'inherit') {
        $subtitle_font_family = 'inherit';
    } elseif ($subtitle_font_default == 'standart') {
        $subtitle_font_family = $subfont_standard_family;
    } else {
        $subtitle_font_family = 'inherit';
    }

    wp_enqueue_style(
            'custom-style', plugin_dir_url(__FILE__) . 'frontend/css/coyote-np-style.css'
    );
	$custom = '';
    $custom .= ".coyote-np-nav-prev h3, .coyote-np-nav-next h3{ font-family: {$title_font_family}!important; font-weight: {$font_weight}!important; }";
	$custom .= ".coyote-np-nav-prev h3 a, .coyote-np-nav-next h3 a{ color: {$title_color}!important; }";
	$custom .= ".coyote-np-nav-prev h3 a:hover, .coyote-np-nav-next h3 a:hover{ color: {$title_color_hover}!important; }";
	$custom .= ".np-thumb-text p{ font-family: {$subtitle_font_family}!important; color: {$subtitle_color}!important; }";
    $custom .= ".coyote-np-nav-prev .arrow-icon, .coyote-np-nav-next .arrow-icon{ border-color: {$content_arrow}!important; background: {$content_arrow}!important; }";
	$custom .= ".coyote-np-nav-prev .np-content, .coyote-np-nav-next .np-content{ background: {$content_background}!important; }";
	
    $custom_css = $custom;


    wp_add_inline_style('custom-style', $custom_css);
}

add_action('wp_enqueue_scripts', 'coyote_np_styles_inline');


function coyote_np_posts_conditional(){
	
	$post_types = get_option('coyote_np_post_type');
	if(!$post_types){ $post_types = array('post'); }	
	
	foreach($post_types as $var){
		
		if ( $var === 'page' ) { 
			if ( is_front_page() && is_home() ) {
				} elseif ( is_front_page() ) {
				} elseif ( is_home() ) {
				} elseif ( is_page() ) {
				} 		
		} elseif( $var === 'home'){
			if ( is_front_page() && is_home() ) {
				  // Default homepage
				} elseif ( is_front_page() ) {
				  // static homepage
				} elseif ( is_home() ) {
				  // blog page
				} 				
		} else { 
				if ( is_singular($var) ) {
					  echo coyote_np_posts_arrows();
					} 		
		}
	}
	
}
add_action( 'wp_footer', 'coyote_np_posts_conditional', 100 );


