<?php 
if( !defined( 'ABSPATH') ) exit();

function coyote_np_posts_metabox() {
	
    $post_types = get_option('coyote_np_post_type');
   
	if ($post_types){
		
		foreach ( $post_types  as $post_type ) {
			if($post_type==='post'){
                add_meta_box('item-np-posts-fields', __('Prev & Next', COYOTE_NP_POSTS_TEXT_DOMAIN ), 'coyote_np_posts_metabox_options', "$post_type", 'side', 'default');
            } 	   
				}		
	}	
}

add_action('admin_init', 'coyote_np_posts_metabox');

function coyote_np_get_posts(){
    global $wpdb; 
    global $post; 
    $current_id = get_the_ID();
	$current_type = get_post_type($current_id);	
	$post_types = get_option('coyote_np_post_type');
    $tablePosts = $wpdb->prefix."posts";
    $data_post_query = $wpdb->get_results( "	
        SELECT p.ID, p.post_title, p.post_type, p.post_date FROM $tablePosts AS p
         WHERE p.post_status='publish' AND post_type = '$current_type' AND p.ID NOT LIKE '$current_id'
            "					
        );
    $data_post_query = cvf_convert_object_to_array($data_post_query);	
    $data_post = $data_post_query[0]['post_date'];
    return $data_post_query;
}

function coyote_np_posts_metabox_options() {
    global $post; 
    $posts = coyote_np_get_posts();
    wp_nonce_field('coyote_np_posts_metabox_nonce', 'coyote_np_posts_metabox_nonce');
    
    $coyote_np_posts_stored_meta = get_post_meta($post->ID);
    ?>
    <p><strong><?php _e('Mode', COYOTE_NP_POSTS_TEXT_DOMAIN)?>:</strong></p>
	<p>
    <label><?php _e('Select automatic or custom, automatic is the default', COYOTE_NP_POSTS_TEXT_DOMAIN)?></label>	
	<ul>
        <li>
            <a href="http://coyotewp.com/prev-next/" class="coy-tooltip" style="color: #ff0000;" target="_blank">
                <?php _e('Get PRO Version', COYOTE_NP_POSTS_TEXT_DOMAIN); ?>
            </a>
        </li> 
    </ul>
    <br />
    <?php if ( isset ( $coyote_np_posts_stored_meta ['meta_coyote_np_posts_control'])) {
        $control = $coyote_np_posts_stored_meta ['meta_coyote_np_posts_control'][0];
    } else {
        $control  = '';
    } ?>
    <select id="control-type" name="meta_coyote_np_posts_control">	
        <option id="0" value="none" <?php if ( $control === 'none' ) { echo 'selected="selected"'; } ?> ><?php _e('Automatic', COYOTE_NP_POSTS_TEXT_DOMAIN)?></option>
        <option id="1" value="custom" <?php if ( $control === 'custom' ) { echo 'selected="selected"'; } ?> ><?php _e('Custom', COYOTE_NP_POSTS_TEXT_DOMAIN)?></option>                                          
    </select>
</p>
<script type="text/javascript">
    jQuery(document).ready(function ($) {
        var selectVal = $('#control-type').val();
            if(selectVal==='none'){
                $(".custom_navagation").hide();
            }else{
                $(".custom_navagation").show();
            }

        $("#meta_coyote_np_posts_id_next").prop('disabled', true);
        $("#meta_coyote_np_posts_id_prev").prop('disabled', true);
        $("#meta_coyote_np_posts_id_next_custom_text").prop('disabled', true);
        $("#meta_coyote_np_posts_id_prev_custom_text").prop('disabled', true);    

        $('#control-type').change(function() {
            
            var selectVal = $(this).val();
            if(selectVal==='none'){
                $(".custom_navagation").hide();
            }else{
                $(".custom_navagation").show();
            }  

        });  

        $('#meta_coyote_np_posts_id_next').change(function() {
            var selectValNext = $(this).val();
            var selectValPrev = $('#meta_coyote_np_posts_id_prev').val();
            if(selectValNext === selectValPrev && selectValNext!='' && selectValPrev!=''){
                $('#meta_coyote_np_posts_id_prev').val('').change();
                alert('Change value in selection Prev.');
            }

        });

        $('#meta_coyote_np_posts_id_prev').change(function() {
            var selectValPrev = $(this).val();
            var selectValNext = $('#meta_coyote_np_posts_id_next').val();
            if(selectValNext === selectValPrev && selectValNext!='' && selectValPrev!=''){
                $('#meta_coyote_np_posts_id_next').val('').change();
                alert('Change value in selection Next..');
            } 

        });

    });
</script>
<div class="custom_navagation">	
    <p><strong>Next:</strong>&nbsp<span style="color: #ff0000;">(pro)</span></p>
    <p>
        <label><?php _e('ID:', COYOTE_NP_POSTS_TEXT_DOMAIN)?></label>
        <?php if ( isset ( $coyote_np_posts_stored_meta ['meta_coyote_np_posts_id_next'])) {
                $control = $coyote_np_posts_stored_meta ['meta_coyote_np_posts_id_next'][0];
                } else {
                    $control  = '';
                }
        ?>
        <select name="meta_coyote_np_posts_id_next" id="meta_coyote_np_posts_id_next">
            <option  value="" <?php if ( $control == '' ) { echo 'selected="selected"'; } ?>><?php _e('Select a item')?></option>	
        <?php foreach($posts as $item):?>
            <option  value="<?php _e($item['ID'])?>" <?php if ( $control == $item['ID'] ) { echo 'selected="selected"'; } ?> ><?php _e($item['ID']);_e(' - '); _e(substr($item['post_title'], 0, 20));?></option>
        <?php endforeach; ?>    
        </select>
    </p>
    <p>
        <label><?php _e('Custom Text:', COYOTE_NP_POSTS_TEXT_DOMAIN)?></label>
        <input type="text" name="meta_coyote_np_posts_id_next_custom_text" id="meta_coyote_np_posts_id_next_custom_text" value="<?php if ( isset ( $coyote_np_posts_stored_meta ['meta_coyote_np_posts_id_next_custom_text'] ) ) { _e($coyote_np_posts_stored_meta ['meta_coyote_np_posts_id_next_custom_text'][0]);} ?>" /> 
    </p>
    <p><strong>Prev:</strong>&nbsp<span style="color: #ff0000;">(pro)</span></p>
    <p>
        <label><?php _e('ID:', COYOTE_NP_POSTS_TEXT_DOMAIN)?></label>
        <?php if ( isset ( $coyote_np_posts_stored_meta ['meta_coyote_np_posts_id_prev'])) {
                $control = $coyote_np_posts_stored_meta ['meta_coyote_np_posts_id_prev'][0];
                } else {
                    $control  = '';
                }
        ?>
        <select name="meta_coyote_np_posts_id_prev" id="meta_coyote_np_posts_id_prev">
            <option  value="" <?php if ( $control == '' ) { echo 'selected="selected"'; } ?>><?php _e('Select a item', COYOTE_NP_POSTS_TEXT_DOMAIN)?></option>
        <?php foreach($posts as $item):?>
            <option  value="<?php _e($item['ID'])?>" <?php if ( $control == $item['ID'] ) { echo 'selected="selected"'; } ?> ><?php _e($item['ID']);_e(' - '); _e(substr($item['post_title'], 0, 20));?></option>
        <?php endforeach; ?>      
        </select> 
    </p>
    <p>
        <label><?php _e('Custom Text:', COYOTE_NP_POSTS_TEXT_DOMAIN)?></label>
        <input type="text" name="meta_coyote_np_posts_id_prev_custom_text" id="meta_coyote_np_posts_id_prev_custom_text" value="<?php if ( isset ( $coyote_np_posts_stored_meta ['meta_coyote_np_posts_id_prev_custom_text'] ) ) { _e($coyote_np_posts_stored_meta ['meta_coyote_np_posts_id_prev_custom_text'][0]);} ?>" /> 
    </p>
</div>
<?php      
} 

function  coyote_np_posts_metabox_save($post_id) {

    global $post;
    // Checks save status
	$is_autosave = wp_is_post_autosave($post_id);
	$is_revision = wp_is_post_revision($post_id);
	$is_valid_nonce = ( isset( $_POST['coyote_np_posts_metabox_nonce'] ) && wp_verify_nonce( $_POST[ 'coyote_np_posts_metabox_nonce' ], basename( __FILE__ ) ) ) ? 'true' : 'false';
 
	// Exits script depending on save status
    if ($is_autosave || $is_revision || !$is_valid_nonce) {
        return;
    }

    // Checks for input and saves if needed
    if (isset($_POST['meta_coyote_np_posts_control'])) {
        $data = sanitize_text_field($_POST['meta_coyote_np_posts_control']);
        update_post_meta($post_id, 'meta_coyote_np_posts_control', $data);
    }
    if (isset($_POST['meta_coyote_np_posts_id_next'])) {
        $data = sanitize_text_field($_POST['meta_coyote_np_posts_id_next']);
        update_post_meta($post_id, 'meta_coyote_np_posts_id_next', $data);
    }
	if (isset($_POST['meta_coyote_np_posts_id_next_custom_text'])) {
        $data = sanitize_text_field($_POST['meta_coyote_np_posts_id_next_custom_text']);
        update_post_meta($post_id, 'meta_coyote_np_posts_id_next_custom_text', $data);
    }
	if (isset($_POST['meta_coyote_np_posts_id_prev'])) {
        $data = sanitize_text_field($_POST['meta_coyote_np_posts_id_prev']);
        update_post_meta($post_id, 'meta_coyote_np_posts_id_prev', $data);
    }
	if (isset($_POST['meta_coyote_np_posts_id_prev_custom_text'])) {
        $data = sanitize_text_field($_POST['meta_coyote_np_posts_id_prev_custom_text']);
        update_post_meta($post_id, 'meta_coyote_np_posts_id_prev_custom_text', $data);
    }
        
        
}

add_action('save_post', 'coyote_np_posts_metabox_save');

